part of 'fragment_container.dart';

abstract class Fragment extends StatefulWidget {
  @override
  FragmentKey get key => super.key as FragmentKey;

  const Fragment({required FragmentKey key}) : super(key: key);

  @override
  FragmentState<Fragment> createState();
}

abstract class FragmentState<T extends Fragment> extends State<T> {
  FragmentManager get manager => FragmentContainer.of(context);

  @override
  void debugFillProperties(DiagnosticPropertiesBuilder properties) {
    super.debugFillProperties(properties);
    properties.add(DiagnosticsProperty<FragmentManager>('manager', manager));
  }
}

@optionalTypeArgs
class FragmentKey<T extends FragmentState> extends GlobalKey<T> {
  final String name;

  const FragmentKey(this.name) : super.constructor();

  @override
  bool operator ==(Object other) => other is FragmentKey<T> && identical(other.name, name);

  @override
  int get hashCode => identityHashCode(name);

  @override
  String toString() => 'FragmentKey($name)';
}
